=== debian/changelog ===
gpsbabel (1.9.0+ds-3) unstable; urgency=medium

  * Depend on locales-all for tests

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 08 Jun 2024 14:07:37 +0200

gpsbabel (1.9.0+ds-2) unstable; urgency=medium

  * Fix man page generation
  * Fix build on 32bit archs

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 24 Oct 2023 16:08:38 +0200

gpsbabel (1.9.0+ds-1) unstable; urgency=medium

  * New upstream version
  * Update d/copyright
  * Rebase patches
  * Switch build system to cmake
  * Update d/clean (Closes: #1044858)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 23 Oct 2023 11:27:32 +0200

gpsbabel (1.8.0+ds-7) unstable; urgency=medium

  * Fix package short description (Closes: #1042359)

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 27 Jul 2023 11:10:25 +0200

gpsbabel (1.8.0+ds-6) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Don't use qtwebengine5-dev on mipsel, package to be removed
    (Closes: #1041912)

  [ Jochen Sprickerhof ]
  * Bump policy version (no changes)
  * Move package description to source package

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 25 Jul 2023 11:47:33 +0200
