=== debian/control ===
Source: gpsbabel
Section: utils
Priority: optional
Maintainer: Debian GPS team <gpsbabel@packages.debian.org>
Uploaders: Bernd Zeimetz <bzed@debian.org>, Jochen Sprickerhof <jspricke@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 pkgconf,
 libexpat1-dev, expat,
 libxml2-utils,
 libusb-1.0-0-dev, zlib1g-dev,
 libshp-dev,
 locales-all <!nocheck>,
 qt6-5compat-dev,
 qt6-base-dev,
 qt6-serialport-dev,
 qt6-tools-dev,
 qt6-translations-l10n,
 qt6-webengine-dev [amd64 arm64 armhf i386],
 imagemagick,
 xsltproc,
 docbook-xsl
Build-Depends-Indep: fop, docbook-xml
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://www.gpsbabel.org/
Vcs-Git: https://salsa.debian.org/debian-gps-team/pkg-gpsbabel.git
Vcs-Browser: https://salsa.debian.org/debian-gps-team/pkg-gpsbabel
Description: GPS file conversion plus transfer to/from GPS units
 GPSBabel converts waypoints, tracks, and routes from one format to
 another, whether that format is a common mapping format like Delorme,
 Streets and Trips, or even a serial upload or download to a GPS unit
 such as those from Garmin and Magellan.

Package: gpsbabel
Architecture: any
Recommends: gpsbabel-doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 GPSBabel supports dozens of data formats and will be useful for tasks
 such as geocaching, mapping, and converting from one GPS unit to another.
 Among the interesting formats it supports are several GPS devices via
 a serial link, various PDA-based mapping programs, and various
 Geocaching data formats.
 .
 Among others GPSBabel supports the following formats:
 .
 CSV, Custom CSV DNA, EasyGPS Binary, Fugawi, Garmin serial, Geocaching.com
 loc, GPSDrive, GPX, Holux, IGC, Magellan serial, Magellan SD, Mapopolis.Com
 Mapconverter, Mapsource, Maptech, Microsoft Streets and Trips, NIMA/GNIS
 Geographic Names, NMEA sentences, OziExplorer, Tab-separated data, Topo by
 National Geographic, xcsv

Package: gpsbabel-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: gpsbabel, pdf-viewer | www-browser
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 GPSBabel supports dozens of data formats and will be useful for tasks
 such as geocaching, mapping, and converting from one GPS unit to another.
 Among the interesting formats it supports are several GPS devices via
 a serial link, various PDA-based mapping programs, and various
 Geocaching data formats.
 .
 This package contains the detailed documentation of gpsbabel.

Package: gpsbabel-gui
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gpsbabel (= ${binary:Version}), gpsbabel-doc (= ${source:Version})
Recommends: qttranslations5-l10n
Description: ${source:Synopsis} - GUI
 ${source:Extended-Description}
 .
 This package contains gpsbabelfe, a QT based frontend for gpsbabel.
