## gpsbabel 1.10.0%2Bds

=== debian/changelog ===
gpsbabel (1.10.0+ds-2build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@debian.org>  Tue, 03 Feb 2026 23:22:00 +0100

gpsbabel (1.10.0+ds-2) unstable; urgency=medium

  * Add patch to disable failing xmllint (Closes: #1113345, #1096761)

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 02 Sep 2025 16:42:35 +0200

gpsbabel (1.10.0+ds-1) unstable; urgency=medium

  * New upstream version
  * Drop qtci from Files-Excluded (dropped upstream)
  * Update d/copyright
  * Update d/patches
  * Bump policy version (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 11 Jan 2025 08:01:10 +0100
