## gpsbabel 1.10.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.11)
+cmake_minimum_required(VERSION 3.16)
 
 include(CMakeDependentOption)
 include(CheckIncludeFile)
@@ -6,7 +6,7 @@
 include(gbversion.cmake)
 project(gpsbabel LANGUAGES C CXX VERSION ${GB.VERSION})
 
-set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_STANDARD_REQUIRED True)
 
 # Do this after we set up common variables but before creating other
@@ -26,37 +26,45 @@
 add_executable(gpsbabel)
 
 # Find the QtCore library
-find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
-find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core REQUIRED)
-list(APPEND QT_LIBRARIES Qt${QT_VERSION_MAJOR}::Core)
-if(${Qt${QT_VERSION_MAJOR}Core_VERSION} VERSION_LESS 5.12)
-  message(FATAL_ERROR "Qt version ${Qt${QT_VERSION_MAJOR}Core_VERSION} found, but version 5.12 or newer is required.")
+find_package(Qt6 REQUIRED COMPONENTS Core Core5Compat)
+list(APPEND QT_LIBRARIES Qt6::Core Qt6::Core5Compat)
+if(${Qt6Core_VERSION} VERSION_LESS 6.2)
+  message(FATAL_ERROR "Qt version ${Qt6Core_VERSION} found, but version 6.2 or newer is required.")
 else()
-  message(STATUS "Using Qt${QT_VERSION_MAJOR} version ${Qt${QT_VERSION_MAJOR}Core_VERSION}")
-endif()
-if(${QT_VERSION_MAJOR} EQUAL "6")
-  find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core5Compat REQUIRED)
-  list(APPEND QT_LIBRARIES Qt${QT_VERSION_MAJOR}::Core5Compat)
+  message(STATUS "Using Qt6 version ${Qt6Core_VERSION}")
+endif()
+if(${Qt6Core_VERSION} VERSION_GREATER_EQUAL 6.5)
+  target_compile_definitions(gpsbabel PRIVATE LIGHTWEIGHT_TIMEZONES_SUPPORTED)
 endif()
 
 option(GPSBABEL_ENABLE_PCH "enable precompiled headers." ON)
 if (GPSBABEL_ENABLE_PCH)
+  # This list is from defs.h.
   target_precompile_headers(gpsbabel PRIVATE
-    "$<$<COMPILE_LANGUAGE:CXX>:<algorithm$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<cmath$<ANGLE-R>>"
-    "$<$<COMPILE_LANGUAGE:CXX>:<cstdarg$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<cstddef$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<cstdint$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<cstdio$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<ctime$<ANGLE-R>>"
+    "$<$<COMPILE_LANGUAGE:CXX>:<numbers$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<optional$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<utility$<ANGLE-R>>"
+    "$<$<COMPILE_LANGUAGE:CXX>:<QByteArray$<ANGLE-R>>"
+    "$<$<COMPILE_LANGUAGE:CXX>:<QDate$<ANGLE-R>>"
+    "$<$<COMPILE_LANGUAGE:CXX>:<QTime$<ANGLE-R>>"
+    "$<$<COMPILE_LANGUAGE:CXX>:<QDateTime$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<QDebug$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<QList$<ANGLE-R>>"
-    "$<$<COMPILE_LANGUAGE:CXX>:<QScopedPointer$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<QString$<ANGLE-R>>"
+    "$<$<COMPILE_LANGUAGE:CXX>:<QStringView$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<QTextCodec$<ANGLE-R>>"
-    "$<$<COMPILE_LANGUAGE:CXX>:<QVector$<ANGLE-R>>"
+  )
+  if(${Qt6Core_VERSION} VERSION_GREATER_EQUAL 6.5)
+    target_precompile_headers(gpsbabel PRIVATE
+      "$<$<COMPILE_LANGUAGE:CXX>:<QTimeZone$<ANGLE-R>>"
+    )
+  endif()
+  target_precompile_headers(gpsbabel PRIVATE
     "$<$<COMPILE_LANGUAGE:CXX>:<Qt$<ANGLE-R>>"
     "$<$<COMPILE_LANGUAGE:CXX>:<QtGlobal$<ANGLE-R>>"
   )
@@ -153,7 +161,7 @@
   jeeps/gpsusbcommon.cc
   jeeps/gpsusbread.cc
   jeeps/gpsusbsend.cc
-  jeeps/jgpsutil.cc
+  jeeps/gpsutil.cc
 )
 
 # SUPPORT
@@ -170,10 +178,12 @@
   inifile.cc
   main.cc
   mkshort.cc
+  option.cc
   parse.cc
   rgbcolors.cc
   route.cc
   session.cc
+  src/core/codecdevice.cc
   src/core/logging.cc
   src/core/nvector.cc
   src/core/textstream.cc
@@ -187,9 +197,6 @@
   waypt.cc
   xmlgeneric.cc
 )
-if(${QT_VERSION_MAJOR} EQUAL "6")
-  set(SUPPORT ${SUPPORT} src/core/codecdevice.cc)
-endif()
 
 # HEADERS
 set(HEADERS
@@ -201,6 +208,7 @@
   filter_vecs.h
   format.h
   formspec.h
+  garmin.h
   garmin_fit.h
   garmin_fs.h
   garmin_gpi.h
@@ -209,6 +217,8 @@
   gbfile.h
   gbser.h
   gbser_private.h
+  garmin_txt.h
+  garmin_xt.h
   gdb.h
   geocache.h
   geojson.h
@@ -217,18 +227,20 @@
   googletakeout.h
   gpx.h
   grtcirc.h
+  gtm.h
   gtrnctr.h
   heightgrid.h
   humminbird.h
   html.h
   inifile.h
   kml.h
-  legacyformat.h
   igc.h
   lowranceusr.h
   mkshort.h
+  mtk_logger.h
   nmea.h
   osm.h
+  ozi.h
   qstarz_bl_1000.h
   random.h
   session.h
@@ -236,8 +248,12 @@
   skytraq.h
   subrip.h
   text.h
+  tpg.h
+  tpo.h
   unicsv.h
   units.h
+  v900.h
+  vcf.h
   vecs.h
   xcsv.h
   xmlgeneric.h
@@ -247,7 +263,6 @@
   jeeps/gpscom.h
   jeeps/gpsdatum.h
   jeeps/gpsdevice.h
-  jeeps/gpsfmt.h
   jeeps/gpsmath.h
   jeeps/gpsmem.h
   jeeps/gpsport.h
@@ -259,6 +274,7 @@
   jeeps/gpsusbcommon.h
   jeeps/gpsusbint.h
   jeeps/gpsutil.h
+  src/core/codecdevice.h
   src/core/datetime.h
   src/core/file.h
   src/core/logging.h
@@ -269,9 +285,6 @@
   src/core/xmlstreamwriter.h
   src/core/xmltag.h
 )
-if(${QT_VERSION_MAJOR} EQUAL "6")
-  set(HEADERS ${HEADERS} src/core/codecdevice.h)
-endif()
 
 string(REPLACE .cc .h FILTER_HEADERS "${FILTERS}")
 set(HEADERS ${HEADERS} ${FILTER_HEADERS})
@@ -284,9 +297,7 @@
 
 if(WIN32)
   target_compile_definitions(gpsbabel PRIVATE __WIN32__)
-  if(${QT_VERSION_MAJOR} EQUAL "6")
-    qt_disable_unicode_defines(gpsbabel)
-  endif()
+  qt_disable_unicode_defines(gpsbabel)
   if(CMAKE_BUILD_TYPE STREQUAL Debug)
     target_compile_definitions(gpsbabel PRIVATE _DEBUG)
   endif()
@@ -341,10 +352,7 @@
 target_sources(gpsbabel PRIVATE ${SOURCES} ${HEADERS})
 
 # We don't care about stripping things out of the build.  Full monty, baby.
-target_compile_definitions(gpsbabel PRIVATE MAXIMAL_ENABLED)
 target_compile_definitions(gpsbabel PRIVATE FILTERS_ENABLED)
-target_compile_definitions(gpsbabel PRIVATE SHAPELIB_ENABLED)
-target_compile_definitions(gpsbabel PRIVATE CSVFMTS_ENABLED)
 
 target_link_libraries(gpsbabel PRIVATE ${QT_LIBRARIES} ${LIBS})
 
@@ -433,6 +441,7 @@
   validate_formats
   validate
   vcard
+  vecs
   xcsv
 )
 
@@ -496,3 +505,4 @@
                     VERBATIM
                     USES_TERMINAL)
 else()
+  message(WARNING "Document generation is only supported for in-source builds with single configuration generators.")
