=== debian/control ===
--- 
+++ 
@@ -21,7 +21,7 @@
  xsltproc,
  docbook-xsl
 Build-Depends-Indep: fop, docbook-xml
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.gpsbabel.org/
 Vcs-Git: https://salsa.debian.org/debian-gps-team/pkg-gpsbabel.git
